#!/bin/sh

############################################################################
#
#  Source Name : install_su.sh
#  Option      : No option.
#  Result Code : 0    -> No errors occurred.
#                128  -> Failed set_net_lin.sh.
#
############################################################################

TYPE=""
if [ `uname -m` == 'x86_64' ]; then
	TYPE="_x64"
fi

# libs
INST_LIBS_E=( \
libcolour${TYPE}.so.* \
libmctrl${TYPE}.so.* \
libHIDmctrl${TYPE}.so.* \
libmptag${TYPE}.so.* \
libemc${TYPE}.so.* \
libemlock${TYPE}.so.* \
libIccProfLib${TYPE}.so.* \
liblcms2.so.* \
libcndata${TYPE}.so.* \
libcncommon${TYPE}.so.* \
libcn_netagent${TYPE}.so.* \
libeemu${TYPE}.so.* \
libminfo2${TYPE}.so.* \
libeyesys${TYPE}.so.* \
libCSSG2${TYPE}.so.* \
libKMcalib${TYPE}.so.* \
libmSensor${TYPE}.so.* \
libmdcorrector${TYPE}.so.* \
libmeasurementdevice${TYPE}.so.* \
	)

# libs
INST_LIBS_POCO=( \
libPocoFoundation.so.51 \
libPocoNet.so.51 \
libPocoXML.so.51 \
libPocoUtil.so.51 \
libPocoCrypto.so.51 \
libPocoNetSSL.so.51 \
libPocoJSON.so.51 \
	)

# dir
DSTDIR_NETAGENT_BIN="/opt/EIZO/ColorNavigator NetAgent/bin"
DSTDIR_NETAGENT_LIB="/opt/EIZO/ColorNavigator NetAgent/lib"
DSTDIR_NETAGENT_DATA="/var/opt/EIZO/ColorNavigator NetAgent"
DSTDIR_NETAGENT_LOG="/var/opt/EIZO/ColorNavigator NetAgent/log"
DSTDIR_DAEMON="/etc/systemd/system"

# dir
SRCDIR_FILES="files"
SRCDIR_APP="files/app"

# files
SRC_NETAGENT=CNNetAgent
SRC_NETAGENT_CONF=CNNetAgent.conf
SRC_NETAGENT_D=CNNetAgent.service

# 1.
mkdir -p "${DSTDIR_NETAGENT_BIN}"
mkdir -p "${DSTDIR_NETAGENT_LIB}"

# 2.
cp ${SRCDIR_APP}/${SRC_NETAGENT} "${DSTDIR_NETAGENT_BIN}/"
echo "cp ${SRCDIR_APP}/${SRC_NETAGENT} ${DSTDIR_NETAGENT_BIN}/"

# 3.
for i in ${INST_LIBS_E[@]}; do
	cp ${SRCDIR_APP}/${i} "${DSTDIR_NETAGENT_LIB}/"
	echo "cp ${SRCDIR_APP}/${i} ${DSTDIR_NETAGENT_LIB}/"
done

for i in ${INST_LIBS_POCO[@]}; do
	cp ${SRCDIR_APP}/${i} "${DSTDIR_NETAGENT_LIB}/"
	echo "cp ${SRCDIR_APP}/${i} ${DSTDIR_NETAGENT_LIB}/"
done

# 4.
for i in ${INST_LIBS_E[@]}; do
	LIB_RELATIVE_PATH=`ls "${DSTDIR_NETAGENT_LIB}"/${i}`
	LIB_NAME="${LIB_RELATIVE_PATH##*/}"
	ln -s "${DSTDIR_NETAGENT_LIB}/${LIB_NAME}" "${DSTDIR_NETAGENT_LIB}/${LIB_NAME%%[.-]*}.so"
	echo "ln -s "${DSTDIR_NETAGENT_LIB}/${LIB_NAME}" "${DSTDIR_NETAGENT_LIB}/${LIB_NAME%%[.-]*}.so""
done

for i in ${INST_LIBS_POCO[@]}; do
	FNAME=${i%.*}
	ln -s "${DSTDIR_NETAGENT_LIB}/${i}" "${DSTDIR_NETAGENT_LIB}/${FNAME}"
done

/sbin/restorecon "${DSTDIR_NETAGENT_LIB}"/lib*
chcon -t textrel_shlib_t "${DSTDIR_NETAGENT_LIB}"/lib*.so
chcon -t textrel_shlib_t "${DSTDIR_NETAGENT_LIB}"/lib*.so.*

cp ${SRCDIR_FILES}/${SRC_NETAGENT_CONF} /etc/ld.so.conf.d/
/sbin/ldconfig

# 5.
mkdir -p "${DSTDIR_NETAGENT_DATA}"
mkdir -p "${DSTDIR_NETAGENT_LOG}"
mkdir -p "${DSTDIR_NETAGENT_DATA}/bin"

cp uninstall.sh "${DSTDIR_NETAGENT_DATA}"
cp -rf bin/uninstall_su.sh "${DSTDIR_NETAGENT_DATA}/bin/"

chmod -Rf 777 "${DSTDIR_NETAGENT_DATA}"

"${PWD}/bin/set_connection.sh"
"${PWD}/bin/set_proxy.sh"

# 6.
cp ${SRCDIR_FILES}/${SRC_NETAGENT_D} ${DSTDIR_DAEMON}/${SRC_NETAGENT_D}
systemctl daemon-reload
systemctl enable CNNetAgent
systemctl start CNNetAgent
exit 0
